// Code generated by go-swagger; DO NOT EDIT.

//
// Copyright 2021 The Sigstore Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/sigstore/fulcio/pkg/generated/models"
)

// NewSigningCertParams creates a new SigningCertParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSigningCertParams() *SigningCertParams {
	return &SigningCertParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSigningCertParamsWithTimeout creates a new SigningCertParams object
// with the ability to set a timeout on a request.
func NewSigningCertParamsWithTimeout(timeout time.Duration) *SigningCertParams {
	return &SigningCertParams{
		timeout: timeout,
	}
}

// NewSigningCertParamsWithContext creates a new SigningCertParams object
// with the ability to set a context for a request.
func NewSigningCertParamsWithContext(ctx context.Context) *SigningCertParams {
	return &SigningCertParams{
		Context: ctx,
	}
}

// NewSigningCertParamsWithHTTPClient creates a new SigningCertParams object
// with the ability to set a custom HTTPClient for a request.
func NewSigningCertParamsWithHTTPClient(client *http.Client) *SigningCertParams {
	return &SigningCertParams{
		HTTPClient: client,
	}
}

/* SigningCertParams contains all the parameters to send to the API endpoint
   for the signing cert operation.

   Typically these are written to a http.Request.
*/
type SigningCertParams struct {

	/* CertificateRequest.

	   Request for signing certificate
	*/
	CertificateRequest *models.CertificateRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the signing cert params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SigningCertParams) WithDefaults() *SigningCertParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the signing cert params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SigningCertParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the signing cert params
func (o *SigningCertParams) WithTimeout(timeout time.Duration) *SigningCertParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the signing cert params
func (o *SigningCertParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the signing cert params
func (o *SigningCertParams) WithContext(ctx context.Context) *SigningCertParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the signing cert params
func (o *SigningCertParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the signing cert params
func (o *SigningCertParams) WithHTTPClient(client *http.Client) *SigningCertParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the signing cert params
func (o *SigningCertParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCertificateRequest adds the certificateRequest to the signing cert params
func (o *SigningCertParams) WithCertificateRequest(certificateRequest *models.CertificateRequest) *SigningCertParams {
	o.SetCertificateRequest(certificateRequest)
	return o
}

// SetCertificateRequest adds the certificateRequest to the signing cert params
func (o *SigningCertParams) SetCertificateRequest(certificateRequest *models.CertificateRequest) {
	o.CertificateRequest = certificateRequest
}

// WriteToRequest writes these params to a swagger request
func (o *SigningCertParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.CertificateRequest != nil {
		if err := r.SetBodyParam(o.CertificateRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
